// Macro.cpp : implementation file
//

#include "stdafx.h"
#include "xkeymacs.h"
#include "XkeymacsDlg.h"
#include "Macro.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMacro dialog


CMacro::CMacro(CWnd* pParent /*=NULL*/)
	: CDialog(CMacro::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMacro)
	m_nState = -1;
	//}}AFX_DATA_INIT

	m_nnCodeColumn = 0;
	m_nwParamColumn = 0;
	m_nlParamColumn = 0;
	m_nKeyColumn = 0;
	m_nStateColumn = 0;
	m_nExtendedKeyColumn = 0;
	m_nRepeatedKeyColumn = 0;
}


void CMacro::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMacro)
	DDX_Control(pDX, IDC_SUBSEQUENT_KEYBOARD_INPUT, m_cSubsequentKeyboardInput);
	DDX_Radio(pDX, IDC_STATE, m_nState);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMacro, CDialog)
	//{{AFX_MSG_MAP(CMacro)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_NOTIFY(NM_CLICK, IDC_SUBSEQUENT_KEYBOARD_INPUT, OnClickSubsequentKeyboardInput)
	ON_NOTIFY(LVN_KEYDOWN, IDC_SUBSEQUENT_KEYBOARD_INPUT, OnKeydownSubsequentKeyboardInput)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMacro message handlers

BOOL CMacro::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	GetDlgItem(IDC_MACRO_NAME)->SetWindowText("New Macro");

	DWORD dwStyle = m_cSubsequentKeyboardInput.GetExtendedStyle();
	dwStyle |= LVS_EX_FULLROWSELECT;
	m_cSubsequentKeyboardInput.SetExtendedStyle(dwStyle);

	// tmp
	int nCol = 0;
	m_nKeyColumn = nCol;
	m_cSubsequentKeyboardInput.InsertColumn(nCol, "Key", LVCFMT_LEFT);	// FIXME for I18N
	m_cSubsequentKeyboardInput.SetColumnWidth(nCol, 50);
	++nCol;
	m_nStateColumn = nCol;
	m_cSubsequentKeyboardInput.InsertColumn(nCol, "State", LVCFMT_LEFT);
	m_cSubsequentKeyboardInput.SetColumnWidth(nCol, 100);
	++nCol;
	m_nExtendedKeyColumn = nCol;
	m_cSubsequentKeyboardInput.InsertColumn(nCol, "Extended Key", LVCFMT_LEFT);
	m_cSubsequentKeyboardInput.SetColumnWidth(nCol, 30);
	++nCol;
	m_nRepeatedKeyColumn = nCol;
	m_cSubsequentKeyboardInput.InsertColumn(nCol, "Repeated Key", LVCFMT_LEFT);
	m_cSubsequentKeyboardInput.SetColumnWidth(nCol, 30);
	++nCol;
	m_nnCodeColumn = nCol;
	m_cSubsequentKeyboardInput.InsertColumn(nCol, "nCode", LVCFMT_LEFT);
	m_cSubsequentKeyboardInput.SetColumnWidth(nCol, 30);
	++nCol;
	m_nwParamColumn = nCol;
	m_cSubsequentKeyboardInput.InsertColumn(nCol, "wParam", LVCFMT_LEFT);
	m_cSubsequentKeyboardInput.SetColumnWidth(nCol, 100);
	++nCol;
	m_nlParamColumn = nCol;
	m_cSubsequentKeyboardInput.InsertColumn(nCol, "lParam", LVCFMT_LEFT);
	m_cSubsequentKeyboardInput.SetColumnWidth(nCol, 100);

	static HANDLE hMacro = NULL;
	if (!hMacro) {
		hMacro = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, 0x3000, "macro");
	}
	if (hMacro) {
		PVOID pView = MapViewOfFile(hMacro, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if (pView) {
			char buf[0x300] = {'\0'};
			KbdMacro_t kbdMacro = {'\0'};
			memset(&kbdMacro, 0, sizeof(KbdMacro_t));
			memcpy(&kbdMacro, (char *) pView, sizeof(KbdMacro_t));
			for (int i = 0; kbdMacro.nCode || kbdMacro.wParam || kbdMacro.lParam; ++i) {
				sprintf(buf, "%#x", kbdMacro.nCode);
				int nItem = m_cSubsequentKeyboardInput.InsertItem(m_cSubsequentKeyboardInput.GetItemCount(), KeyNames[kbdMacro.wParam].szKeyName);
				m_cSubsequentKeyboardInput.SetItemData(nItem, nItem);
				int nCol = 0;
				if (kbdMacro.lParam & BEING_RELEASED) {
					sprintf(buf, "Release");
				} else {
					sprintf(buf, "Press");
				}
				m_cSubsequentKeyboardInput.SetItemText(nItem, ++nCol, buf);
				if (kbdMacro.lParam & EXTENDED_KEY) {
					sprintf(buf, "o");
				} else {
					sprintf(buf, "x");
				}
				m_cSubsequentKeyboardInput.SetItemText(nItem, ++nCol, buf);
				if (kbdMacro.lParam & REPEATED_KEY) {
					sprintf(buf, "o");
				} else {
					sprintf(buf, "x");
				}
				m_cSubsequentKeyboardInput.SetItemText(nItem, ++nCol, buf);
				sprintf(buf, "%#x", kbdMacro.nCode);
				m_cSubsequentKeyboardInput.SetItemText(nItem, ++nCol, buf);
				sprintf(buf, "%#04x", kbdMacro.wParam);
				m_cSubsequentKeyboardInput.SetItemText(nItem, ++nCol, buf);
				sprintf(buf, "%#010x", kbdMacro.lParam);
				m_cSubsequentKeyboardInput.SetItemText(nItem, ++nCol, buf);

				memset(&kbdMacro, 0, sizeof(KbdMacro_t));
				memcpy(&kbdMacro, (char *) pView + sizeof(KbdMacro_t) * i, sizeof(KbdMacro_t));
			}
		}
		UnmapViewOfFile(pView);
	}

	if (!m_cSubsequentKeyboardInput.GetItemCount()) {
		GetDlgItem(IDC_MACRO_NAME)->EnableWindow(FALSE);
		GetDlgItem(IDOK)->EnableWindow(FALSE);
	}

	GetDlgItem(IDC_DELETE)->EnableWindow(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMacro::OnDelete() 
{
	// TODO: Add your control notification handler code here
	POSITION pos = m_cSubsequentKeyboardInput.GetFirstSelectedItemPosition();
	if (pos) {
		int nItem = m_cSubsequentKeyboardInput.GetNextSelectedItem(pos);
		m_cSubsequentKeyboardInput.DeleteItem(nItem);

		if (m_cSubsequentKeyboardInput.GetItemCount()) {
			nItem = __min(nItem, m_cSubsequentKeyboardInput.GetItemCount() - 1);
			m_cSubsequentKeyboardInput.SetItemState(nItem, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
			m_cSubsequentKeyboardInput.SetFocus();
		} else {
			GetDlgItem(IDC_DELETE)->EnableWindow(FALSE);
		}
	}
}

void CMacro::OnClickSubsequentKeyboardInput(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	POSITION pos = m_cSubsequentKeyboardInput.GetFirstSelectedItemPosition();
	GetDlgItem(IDC_DELETE)->EnableWindow(pos != NULL);
	GetSelectedKeyInformation();

	*pResult = 0;
}

void CMacro::OnKeydownSubsequentKeyboardInput(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_DELETE)->EnableWindow(TRUE);
	GetSelectedKeyInformation();	// FIXME	Now old item is selected yet. We must chece not at keydown but at keyup.

	*pResult = 0;
}

void CMacro::GetSelectedKeyInformation()
{
	POSITION pos = m_cSubsequentKeyboardInput.GetFirstSelectedItemPosition();
	if (pos) {
		int nItem = m_cSubsequentKeyboardInput.GetNextSelectedItem(pos);
		GetSelectedKeyInformation(IDC_KEY, nItem, m_nKeyColumn);
		GetSelectedKeyInformation(IDC_STATE, nItem, m_nStateColumn);
		GetSelectedKeyInformation(IDC_EXTENDED_KEY, nItem, m_nExtendedKeyColumn);
		GetSelectedKeyInformation(IDC_REPEATED_KEY, nItem, m_nRepeatedKeyColumn);
		GetSelectedKeyInformation(IDC_NCODE, nItem, m_nnCodeColumn);
		GetSelectedKeyInformation(IDC_WPARAM, nItem, m_nwParamColumn);
		GetSelectedKeyInformation(IDC_LPARAM, nItem, m_nlParamColumn);
	}
	UpdateData(FALSE);
}

void CMacro::GetSelectedKeyInformation(int nID, int nItem, int nSubItem)
{
	CString szString = m_cSubsequentKeyboardInput.GetItemText(nItem, nSubItem);

	switch (nID) {
	case IDC_KEY:
	case IDC_NCODE:
	case IDC_WPARAM:
	case IDC_LPARAM:
		GetDlgItem(nID)->SetWindowText(szString);
		break;
	case IDC_STATE:
		GetDlgItem(nID);
		m_nState = !szString.Compare("Release");
		break;
	case IDC_EXTENDED_KEY:
	case IDC_REPEATED_KEY:
		CheckDlgButton(nID, szString.GetAt(0) == 'o');
		break;
	}
}
